
#include <avr/io.h>
#include "usart.h"

void initUSARTAsynchronous(uint16_t baud){
    USART0.BAUD = baud;
    USART0.CTRLB |= RX_ON | TX_ON;
    USART0.CTRLC = EIGHTNONE;
}

void initUSARTInterrupt(void){
    USART0.CTRLA |= (1<<7);
}

uint8_t readUSART(void){
    uint8_t data = 0;
    while(!(USART0.STATUS&RCIF_BM));
    data = USART0.RXDATAL;
    return data;
}

void sendUSART(uint8_t byte){
    USART0.TXDATAL = byte;
    while(!(USART0.STATUS&TXIF_BM));
}
